//+------------------------------------------------------------------+
//| MZZMatrica.mq4   30  2010                                   |
//+------------------------------------------------------------------+
#property copyright "nen"

#property indicator_chart_window
#property indicator_buffers 8

//---- input parameters
extern string TimeFrame    = "1,5,15,30,60,240,1440,10080,43200";              // ,    
extern string ExtMaxBar    = "5000,1000,1000,1000,1000,1000,1000,800,600,250"; //    (0-)
extern string zzVisible    = "0,1,1,0,1,1,1,1,1";                              // 0 -   , 1 -  
extern string zzColor      = "DarkSeaGreen,DarkGoldenrod,Aqua,SaddleBrown,Red,Yellow,Magenta,Purple,MediumSpringGreen";
extern string zzStyle      = "1,1,1,1,1,1,1,1,1";  //   
extern string zzWidth      = "1,1,1,1,1,1,1,1,1";  //   
extern int   externalBar   = 0;     // 1 -       . 0 -          
extern bool  CurrentTF     = false; //         false -  
extern int   ExtComplekt   = 0;     //  

//---- buffers
double zzh_1[], zzh_2[], zzh_3[], zzh_4[];
double zzl_1[], zzl_2[], zzl_3[], zzl_4[];

int GrossPeriod_[]={0,0,0,0,0,0,0,0,0}, zzVisible_[]={0,0,0,0,0,0,0,0,0}, ExtMaxBar_[]={0,0,0,0,0,0,0,0,0};
int zzColor_[]={0,0,0,0,0,0,0,0,0}, zzStyle_[]={0,0,0,0,0,0,0,0,0}, zzWidth_[]={0,0,0,0,0,0,0,0,0};

double lBar[]={0,0,0,0,0,0,0,0,0}, hBar[]={0,0,0,0,0,0,0,0,0};
datetime tiZZ[]={0,0,0,0,0,0,0,0,0};

double lLast[]={0,0,0,0,0,0,0,0,0}, hLast[]={0,0,0,0,0,0,0,0,0};
datetime tLast[]={0,0,0,0,0,0,0,0,0};



int saveBars, limit; 
int hi[]={0,0,0,0,0,0,0,0,0}, li[]={0,0,0,0,0,0,0,0,0}, hl[]={0,0,0,0,0,0,0,0,0}, saveBarsTF[9];
static int up=1, dn=-1;
/*
tLast -   ,       ,   ()  () ()
*/
//     " "
double save_lLast[]={0,0,0,0,0,0,0,0,0}, save_hLast[]={0,0,0,0,0,0,0,0,0};
datetime save_tLast[]={0,0,0,0,0,0,0,0,0}, save_tbar1[]={0,0,0,0,0,0,0,0,0}, t_hi[]={0,0,0,0,0,0,0,0,0}, t_li[]={0,0,0,0,0,0,0,0,0};
int save_hl[]={0,0,0,0,0,0,0,0,0};
int calculateTF[4];
bool TheExternalBar[9];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   int i, j, k;
//----
   _stringtointarray   (TimeFrame, GrossPeriod_, 9);
   _stringtointarray   (zzVisible, zzVisible_,   9);
   _stringtointarray   (ExtMaxBar, ExtMaxBar_,   9);
   _stringtocolorarray (zzColor,   zzColor_,     9);
   _stringtointarray   (zzStyle,   zzStyle_,     9);
   _stringtointarray   (zzWidth,   zzWidth_,     9);
//---- indicators
   SetIndexBuffer(0,zzh_1);
   SetIndexEmptyValue(0,0.0);
   SetIndexBuffer(1,zzl_1);
   SetIndexEmptyValue(1,0.0);

   SetIndexBuffer(2,zzh_2);
   SetIndexEmptyValue(2,0.0);
   SetIndexBuffer(3,zzl_2);
   SetIndexEmptyValue(3,0.0);

   SetIndexBuffer(4,zzh_3);
   SetIndexEmptyValue(4,0.0);
   SetIndexBuffer(5,zzl_3);
   SetIndexEmptyValue(5,0.0);

   SetIndexBuffer(6,zzh_4);
   SetIndexEmptyValue(6,0.0);
   SetIndexBuffer(7,zzl_4);
   SetIndexEmptyValue(7,0.0);

   ArrayInitialize(zzh_1,0.0); ArrayInitialize(zzh_2,0.0); ArrayInitialize(zzh_3,0.0); ArrayInitialize(zzh_4,0.0);
   ArrayInitialize(zzl_1,0.0); ArrayInitialize(zzl_2,0.0); ArrayInitialize(zzl_3,0.0); ArrayInitialize(zzl_4,0.0);

   ArrayInitialize(calculateTF,-1);
   k=0; if (CurrentTF) j=0; else j=1;
   for (i=_tf(Period(), true)+j;i<9 && k<4;i++)
     {
      if (zzVisible_[i]==1)
        {
         calculateTF[k]=i;
         SetIndexStyle(k*2, DRAW_ZIGZAG, zzStyle_[i], zzWidth_[i], zzColor_[i]);
         SetIndexStyle(k*2+1, DRAW_ZIGZAG, zzStyle_[i], zzWidth_[i], zzColor_[i]);
         k++;
        }
     }
//----
   if (externalBar<0) externalBar=0;
   if (externalBar>1) externalBar=1;

   for (k=0;k<4;k++)
     {
      if (calculateTF[k]<0) continue;
      i=calculateTF[k];
      TheExternalBar[i]=false;
      if (ExtMaxBar_[i]<=0 || ExtMaxBar_[i]>iBars(NULL, GrossPeriod_[i])) ExtMaxBar_[i]=iBars(NULL, GrossPeriod_[i])-1;
     }
   saveBars=0;

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   delete_objects();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   bool calculate;
   int i, k;

   for (k=0;k<4;k++)
     {
      if (Bars-saveBars>1) for (i=0;i<4;i++) {if (calculateTF[k]<0) continue; saveBarsTF[calculateTF[i]]=0;}

      if (calculateTF[k]<0) continue;
      i=calculateTF[k];

      if (iBars(NULL, GrossPeriod_[i])-saveBarsTF[i]>1) saveBars=0;
      saveBarsTF[i]=iBars(NULL, GrossPeriod_[i]);

      limit=Bars-saveBars;
      calculate=false;

      if (limit>1)
        {
         calculate=true;
         initTF (k);
        }
      else
        {
         if (lBar[i]<=iLow(NULL, GrossPeriod_[i], 0) && hBar[i]>=iHigh(NULL, GrossPeriod_[i], 0) && tiZZ[i]==iTime(NULL, GrossPeriod_[i], 0)) continue;
         else {calculate=true; if (tiZZ[i]!=iTime(NULL, GrossPeriod_[i], 0)) {TheExternalBar[i]=false; delete_objects_tf(GrossPeriod_[i]);}}
        }

      if (calculate)
        {
         if (!TheExternalBar[i])
           {
            switch(k)
              {
               case 0: swing(zzl_1, zzh_1, i); break;
               case 1: swing(zzl_2, zzh_2, i); break;
               case 2: swing(zzl_3, zzh_3, i); break;
               case 3: swing(zzl_4, zzh_4, i); 
              }
           }
         saveBars=Bars;
         lBar[i]=iLow(NULL, GrossPeriod_[i], 0); hBar[i]=iHigh(NULL, GrossPeriod_[i], 0); tiZZ[i]=iTime(NULL, GrossPeriod_[i], 0); 
        }

     }
   return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|       . .  |
//+------------------------------------------------------------------+
void initTF (int k)
  {
   int i=calculateTF[k];
   hl[i]=0;
   TheExternalBar[i]=false; delete_objects_tf(GrossPeriod_[i]);
   switch(k)
     {
      case 0: ArrayInitialize(zzh_1,0.0); ArrayInitialize(zzl_1,0.0); break;
      case 1: ArrayInitialize(zzh_2,0.0); ArrayInitialize(zzl_2,0.0); break;
      case 2: ArrayInitialize(zzh_3,0.0); ArrayInitialize(zzl_3,0.0); break;
      case 3: ArrayInitialize(zzh_4,0.0); ArrayInitialize(zzl_4,0.0);
     }
   
  }
//+------------------------------------------------------------------+
//|       . .   |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|  . .                                        |
//+------------------------------------------------------------------+
void swing(double& zzl[], double& zzh[], int i)
  {
   int i1, j, k, n, m, save1_hi, save1_li, TF;
   string nameObj;
   datetime t;

   TF=GrossPeriod_[i];

   if (limit>1)  //  
     {
      if (iBarShift(NULL, TF, Time[Bars-1], false)<ExtMaxBar_[i]) n=iBarShift(NULL, TF, Time[Bars-1], false);
      else n=ExtMaxBar_[i];
      lLast[i]=iLow(NULL, TF, n); hLast[i]=iHigh(NULL, TF, n); tLast[i]=iTime(NULL, TF, n);
      n--;
     }
   else  //   ,      (  )
     {
      n=iBarShift(NULL, TF, save_tbar1[i], false);
      lLast[i]=save_lLast[i]; hLast[i]=save_hLast[i]; tLast[i]=save_tLast[i];
      hi[i]=iBarShift(NULL, Period(), t_hi[i], false); li[i]=iBarShift(NULL, Period(), t_li[i], true);
      hl[i]=save_hl[i];

      if (hi[i]<li[i]) m=hi[i]; else m=li[i];
      for (i1=m-1;i1>=0;i1--) {zzh[i1]=0; zzl[i1]=0;}
     }
//---
   for (i1=n;i1>=0;i1--)
     {
      if (i1==1)
        {
         zzl[1]=0; zzh[1]=0;
         zzl[0]=0; zzh[0]=0;
         //      " "
         save_lLast[i]=lLast[i]; save_hLast[i]=hLast[i]; save_tLast[i]=tLast[i];
         t_hi[i]=Time[hi[i]]; t_li[i]=Time[li[i]];
         save_hl[i]=hl[i];
         save_tbar1[i]=iTime(NULL, TF, i1);
        }

      if (lLast[i]>iLow(NULL, TF, i1) && hLast[i]>=iHigh(NULL, TF, i1))  //  Down
        {
         if (hl[i]==dn) zzl[li[i]]=0; 
         lLast[i]=iLow(NULL, TF, i1); hLast[i]=iHigh(NULL, TF, i1); tLast[i]=iTime(NULL, TF, i1);
         hl[i]=dn; li[i]=searchbarcur(Period(), dn, TF, i); 
         zzl[li[i]]=lLast[i];
        }
      else if (lLast[i]<=iLow(NULL, TF, i1) && hLast[i]<iHigh(NULL, TF, i1))  //  Up
        {
         if (hl[i]==up) zzh[hi[i]]=0; 
         lLast[i]=iLow(NULL, TF, i1); hLast[i]=iHigh(NULL, TF, i1); tLast[i]=iTime(NULL, TF, i1);
         hl[i]=up; hi[i]=searchbarcur(Period(), up, TF, i); 
         zzh[hi[i]]=hLast[i];
        }
      else if (lLast[i]<=iLow(NULL, TF, i1) && hLast[i]>=iHigh(NULL, TF, i1) && i1>0) //   .       .
        {
         if (hl[i]==0) continue;

         //---
         // ,       -   
         if (Period()<TF) k=_tf(Period(), true); else k=_tf(Period()-1, true);
         for (j=k;j>=0;j--)
           {
            hi[i]=searchbarcur(_tf(j, false), up, TF, i); 
            li[i]=searchbarcur(_tf(j, false), dn, TF, i);
            if (hi[i]!=li[i])
              {
               //     
               if (hl[i]==dn && hi[i]<li[i]) {hl[i]=up; hi[i]=searchbarcur(Period(), up, TF, i); zzh[hi[i]]=hLast[i];}
               if (hl[i]==up && hi[i]>li[i]) {hl[i]=dn; li[i]=searchbarcur(Period(), dn, TF, i); zzl[li[i]]=lLast[i];}
               break;
              }
           }
         //---

         tLast[i]=iTime(NULL, TF, i1); lLast[i]=iLow(NULL, TF, i1); hLast[i]=iHigh(NULL, TF, i1);
         if (hl[i]==dn) {hl[i]=up; hi[i]=searchbarcur(Period(), up, TF, i); zzh[hi[i]]=hLast[i];} // li=0;
         else if (hl[i]==up) {hl[i]=dn; li[i]=searchbarcur(Period(), dn, TF, i); zzl[li[i]]=lLast[i];} // hi==0;
        }
      else if (lLast[i]>iLow(NULL, TF, i1) && hLast[i]<iHigh(NULL, TF, i1)) //    ()
        {
         if (hl[i]==0) continue;
         if (i1==0)
           {
            nameObj="_"+ExtComplekt+"_TheExternalBar_on_"+TF;
            t=iTime(NULL, TF, 0);
            ObjectCreate(nameObj,OBJ_ARROW,0,t,High[iBarShift(NULL, 0, t, false)]+Point*3);
            ObjectSet(nameObj, OBJPROP_ARROWCODE, SYMBOL_STOPSIGN) ;
            ObjectSet(nameObj, OBJPROP_COLOR, zzColor_[i]) ;
            TheExternalBar[i]=true;
           }
         save1_hi=hi[i]; save1_li=li[i];
         lLast[i]=iLow(NULL, TF, i1); hLast[i]=iHigh(NULL, TF, i1); tLast[i]=iTime(NULL, TF, i1);

         //---
         //      . .
         // ,    -     
         if (Period()<TF) k=_tf(Period(), true); else k=_tf(Period()-1, true);
         for (j=k;j>=0;j--)
           {
            hi[i]=searchbarcur(_tf(j, false), up, TF, i); 
            li[i]=searchbarcur(_tf(j, false), dn, TF, i);
            if (hi[i]!=li[i]) break;
           }

         if (hi[i]!=li[i])
           {
            if(hl[i]==dn && li[i]>hi[i]) zzl[save1_li]=0;
            if(hl[i]==up && li[i]<hi[i]) zzh[save1_hi]=0;
            if (li[i]>hi[i]) hl[i]=up; else hl[i]=dn;
           }
         else
           {
            if (externalBar==0)
              {
               if (hl[i]==dn)
                 {
                  if ((hLast[i]-zzl[save1_li])<(zzl[save1_li]-lLast[i])) {hl[i]=dn;} else {zzl[save1_li]=0; hl[i]=up;}
                 }
               else
                 {
                  if ((hLast[i]-zzh[save1_hi])<(zzh[save1_hi]-lLast[i])) {zzh[save1_hi]=0; hl[i]=dn;} else {hl[i]=up;}
                 }
              }
            else if (externalBar==1)
              {
               if (hl[i]==dn) {zzl[save1_li]=0; hl[i]=up;}
               else {zzh[save1_hi]=0; hl[i]=dn;}
              }
           }
         //      . .
         //---

         hi[i]=searchbarcur(Period(), up, TF, i); zzh[hi[i]]=hLast[i];
         li[i]=searchbarcur(Period(), dn, TF, i); zzl[li[i]]=lLast[i];
        }
      else
        {
         lLast[i]=iLow(NULL, TF, i1); hLast[i]=iHigh(NULL, TF, i1); tLast[i]=iTime(NULL, TF, i1);
        }

     }
//---

   lBar[i]=iLow(NULL, TF, 0); hBar[i]=iHigh(NULL, TF, 0); tiZZ[i]=iTime(NULL, TF, 0); 
  }
//+------------------------------------------------------------------+
//|  . .                                         |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|     . .                       |
//+------------------------------------------------------------------+
int searchbarcur(int tf, int UpDn, int TF, int i)
  {
   int i1, j, tend;
   double wr;
   string stf;
   i1=-1;
   j=iBarShift(NULL, tf, tLast[i], false); tend=tLast[i]+TF*60;

   while (iTime(NULL, tf, j)<tLast[i] && j>=0) j--;
   if (iTime(NULL, tf, j)>tLast[i]) j++;
//   j++;
//   if (Period()==PERIOD_W1 && TF==PERIOD_MN1) j++;
//   if (Period()==PERIOD_W1 && j<0 && TF==PERIOD_MN1) j=0;

   if (iTime(NULL, tf, j)<tend && j<iBars(NULL,tf) && j>=0)
     {
      if (UpDn==dn)
        {
         wr=1000000;
         while (iTime(NULL, tf, j)<tend && j>=0)
           {
            if (wr>iLow(NULL, tf, j)) {i1=j; wr=iLow(NULL, tf, j); if (NormalizeDouble(wr-lLast[i],Digits)==0 || wr<lLast[i]) return (i1);}
            j--;
           }
        }
      else if (UpDn==up)
        {
         wr=0;
         while (iTime(NULL, tf, j)<tend && j>=0)
           {
            if (wr<iHigh(NULL, tf, j)) {i1=j; wr=iHigh(NULL, tf, j); if (NormalizeDouble(wr-hLast[i],Digits)==0 || wr>hLast[i]) return (i1);}
            j--;
           }
        }
      return (i1);
     }
   else
     {
/*
      if (tf==Period())
        {
         switch (tf)
           {
            case 1:     {stf="M1";  break;}
            case 5:     {stf="M5";  break;}
            case 15:    {stf="M15"; break;}
            case 30:    {stf="M30"; break;}
            case 60:    {stf="H1";  break;}
            case 240:   {stf="H4";  break;}
            case 1440:  {stf="D1";  break;}
            case 10080: {stf="W1";  break;}
            case 43200: {stf="MN";}
           }

         j=iBarShift(NULL, tf, tLast, false);
         if (j<iBars(NULL,tf)) Print("  ",stf,"      ",TimeToStr(tLast,TIME_DATE|TIME_MINUTES),"    =",TF,"  "); 
        }
*/
      return (-1);
     }

  }
//+------------------------------------------------------------------+
//|     . .                         |
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//|   . .                        |
//+------------------------------------------------------------------+
/*
y=true -  TF    
1     - 0
5     - 1
15    - 2
30    - 3
60    - 4
240   - 5
1440  - 6
10080 - 7
43200 - 8

y=false -       ( )
*/
int _tf (int tf, bool y)
  {
   if (y)
     {
      if (tf<5)          return (0);
      else if (tf<15)    return (1);
      else if (tf<30)    return (2);
      else if (tf<60)    return (3);
      else if (tf<240)   return (4);
      else if (tf<1440)  return (5);
      else if (tf<10080) return (6);
      else if (tf<43200) return (7);
      return (8);
     }
   else
     {
      if (tf==0)      return (PERIOD_M1);
      else if (tf==1) return (PERIOD_M5);
      else if (tf==2) return (PERIOD_M15);
      else if (tf==3) return (PERIOD_M30);
      else if (tf==4) return (PERIOD_H1);
      else if (tf==5) return (PERIOD_H4);
      else if (tf==6) return (PERIOD_D1);
      else if (tf==7) return (PERIOD_W1);
      else if (tf>=8) return (PERIOD_MN1);
      else if (tf<0)  return (-1);
     }
  }
//+------------------------------------------------------------------+
//|   . .                         |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|  . .                                       |
//+------------------------------------------------------------------+
 void delete_objects_tf(int TF)
  {
   string nameObj="_"+ExtComplekt+"_TheExternalBar_on_"+TF;
   ObjectDelete (nameObj);
  }
//+------------------------------------------------------------------+
//|  . .                                        |
//+------------------------------------------------------------------+
 
//+------------------------------------------------------------------+
//|  . .                                       |
//+------------------------------------------------------------------+
 void delete_objects()
  {
   int i;
   string txt;

   for (i=ObjectsTotal(); i>=0; i--)
     {
      txt=ObjectName(i);
      if (StringFind(txt,"_" + ExtComplekt + "_TheExternalBar_on_")>-1) ObjectDelete (txt);
     }
  }
//+------------------------------------------------------------------+
//|  . .                                        |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|        . . |
//+------------------------------------------------------------------+
void _stringtointarray (string str, int& arr[], int x)
  {
   int i,j,k=0;
   for (i=0;i<x;i++)
     {
      j=StringFind(str,",",k);
      if (j<0) {arr[i]=StrToInteger(StringSubstr(str,k)); break;}
      arr[i]=StrToInteger(StringSubstr(str,k,j-k));
      k=j+1;
     }
  }
//+------------------------------------------------------------------+
//|        ..   |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|        . . |
//+------------------------------------------------------------------+
void _stringtocolorarray (string str, int& arr[], int x)
  {
   int i,j,k=0;
   for (i=0;i<x;i++)
     {
      j=StringFind(str,",",k);
      if (j<0) {arr[i]=fStrToColor(StringSubstr(str,k)); break;}
      arr[i]=fStrToColor(StringSubstr(str,k,j-k));
      k=j+1;
     }
  }
//+------------------------------------------------------------------+
//|        ..   |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|    . .                            |
//|   Integer.  http://forum.mql4.com/ru/7134          |
//+------------------------------------------------------------------+
color fStrToColor(string aName)
  {
 
   color tColor[]={  Black, DarkGreen, DarkSlateGray, Olive, Green, Teal, Navy, Purple, 
                     Maroon, Indigo, MidnightBlue, DarkBlue, DarkOliveGreen, SaddleBrown, 
                     ForestGreen, OliveDrab, SeaGreen, DarkGoldenrod, DarkSlateBlue, 
                     Sienna, MediumBlue, Brown, DarkTurquoise, DimGray, LightSeaGreen, 
                     DarkViolet, FireBrick, MediumVioletRed, MediumSeaGreen, Chocolate, 
                     Crimson, SteelBlue, Goldenrod, MediumSpringGreen, LawnGreen, 
                     CadetBlue, DarkOrchid, YellowGreen, LimeGreen, OrangeRed, DarkOrange, 
                     Orange, Gold, Yellow, Chartreuse, Lime, SpringGreen, Aqua, DeepSkyBlue, 
                     Blue, Magenta, Red, Gray, SlateGray, Peru, BlueViolet, LightSlateGray, 
                     DeepPink, MediumTurquoise, DodgerBlue, Turquoise, RoyalBlue, SlateBlue, 
                     DarkKhaki, IndianRed, MediumOrchid, GreenYellow, MediumAquamarine, 
                     DarkSeaGreen, Tomato, RosyBrown, Orchid, MediumPurple, PaleVioletRed, 
                     Coral, CornflowerBlue, DarkGray, SandyBrown, MediumSlateBlue, Tan, 
                     DarkSalmon, BurlyWood, HotPink, Salmon, Violet, LightCoral, SkyBlue, 
                     LightSalmon, Plum, Khaki, LightGreen, Aquamarine, Silver, LightSkyBlue, 
                     LightSteelBlue, LightBlue, PaleGreen, Thistle, PowderBlue, PaleGoldenrod, 
                     PaleTurquoise, LightGray, Wheat, NavajoWhite, Moccasin, LightPink, 
                     Gainsboro, PeachPuff, Pink, Bisque, LightGoldenrod, BlanchedAlmond, 
                     LemonChiffon, Beige, AntiqueWhite, PapayaWhip, Cornsilk, LightYellow, 
                     LightCyan, Linen, Lavender, MistyRose, OldLace, WhiteSmoke, Seashell, 
                     Ivory, Honeydew, AliceBlue, LavenderBlush, MintCream, Snow, White
                  };  
   string tName[]={   "Black", "DarkGreen", "DarkSlateGray", "Olive", "Green", "Teal", "Navy", "Purple", 
                     "Maroon", "Indigo", "MidnightBlue", "DarkBlue", "DarkOliveGreen", "SaddleBrown", 
                     "ForestGreen", "OliveDrab", "SeaGreen", "DarkGoldenrod", "DarkSlateBlue", 
                     "Sienna", "MediumBlue", "Brown", "DarkTurquoise", "DimGray", "LightSeaGreen", 
                     "DarkViolet", "FireBrick", "MediumVioletRed", "MediumSeaGreen", "Chocolate", 
                     "Crimson", "SteelBlue", "Goldenrod", "MediumSpringGreen", "LawnGreen", 
                     "CadetBlue", "DarkOrchid", "YellowGreen", "LimeGreen", "OrangeRed", "DarkOrange", 
                     "Orange", "Gold", "Yellow", "Chartreuse", "Lime", "SpringGreen", "Aqua", "DeepSkyBlue", 
                     "Blue", "Magenta", "Red", "Gray", "SlateGray", "Peru", "BlueViolet", "LightSlateGray", 
                     "DeepPink", "MediumTurquoise", "DodgerBlue", "Turquoise", "RoyalBlue", "SlateBlue", 
                     "DarkKhaki", "IndianRed", "MediumOrchid", "GreenYellow", "MediumAquamarine", 
                     "DarkSeaGreen", "Tomato", "RosyBrown", "Orchid", "MediumPurple", "PaleVioletRed", 
                     "Coral", "CornflowerBlue", "DarkGray", "SandyBrown", "MediumSlateBlue", "Tan", 
                     "DarkSalmon", "BurlyWood", "HotPink", "Salmon", "Violet", "LightCoral", "SkyBlue", 
                     "LightSalmon", "Plum", "Khaki", "LightGreen", "Aquamarine", "Silver", "LightSkyBlue", 
                     "LightSteelBlue", "LightBlue", "PaleGreen", "Thistle", "PowderBlue", "PaleGoldenrod", 
                     "PaleTurquoise", "LightGray", "Wheat", "NavajoWhite", "Moccasin", "LightPink", 
                     "Gainsboro", "PeachPuff", "Pink", "Bisque", "LightGoldenrod", "BlanchedAlmond", 
                     "LemonChiffon", "Beige", "AntiqueWhite", "PapayaWhip", "Cornsilk", "LightYellow", 
                     "LightCyan", "Linen", "Lavender", "MistyRose", "OldLace", "WhiteSmoke", "Seashell", 
                     "Ivory", "Honeydew", "AliceBlue", "LavenderBlush", "MintCream", "Snow", "White"
                  };

   aName=StringTrimLeft(StringTrimRight(aName));      
   for(int i=0;i<ArraySize(tName);i++)
     {
      if(aName==tName[i])return(tColor[i]);
     }

  return(Red);                                     
                
 }
//+------------------------------------------------------------------+
//|    . .                             |
//|   Integer.  http://forum.mql4.com/ru/7134          |
//+------------------------------------------------------------------+

